import React, { Dispatch, SetStateAction, ReactNode, MutableRefObject } from "react";
import { RuleFn } from "./rules";
export declare type ValuesBlurred = {
    [key: string]: boolean;
};
export declare type RulesRef = {
    [key: string]: RuleFn[];
};
export declare type Error = {
    name: string;
    message: string;
};
declare type Context = {
    rules: MutableRefObject<RulesRef>;
    values: any;
    errors: Error[];
    valuesBlurred: ValuesBlurred;
    hasBlurred: (name: string) => any;
    setErrors: Dispatch<SetStateAction<Error[]>>;
    updateValue: (name: string, value: string) => any;
    setValuesBlurred: Dispatch<SetStateAction<ValuesBlurred>>;
};
declare const FormContext: React.Context<Context>;
export declare type FormProps<Values> = {
    values: Values;
    children: ReactNode;
    onValues: Dispatch<SetStateAction<any>>;
};
declare function Form<Values>({ children, onValues, values }: FormProps<Values>): JSX.Element;
declare const FormContextConsumer: React.Consumer<Context>;
export { FormContext, Form, FormContextConsumer };
